using UnityEngine;
using DiskCardGame;
using HarmonyLib;
using Infiniscryption.Core.Helpers;
using InscryptionAPI.Guid;
using Infiniscryption.SideDecks.Sigils;
using InscryptionAPI.Card;
using Infiniscryption.SideDecks;
using System.Collections.Generic;
using System.Linq;
using Infiniscryption.PackManagement;
using System;
using InscryptionAPI.Helpers;

namespace Infiniscryption.SideDecks.Patchers
{
    public static class CustomCards
    {
        public static readonly List<Ability> sideDeckableAbilities = new List<Ability>() {
            Ability.ConduitNull
        };

        private static void RegisterMetacategoriesInner()
        {
            PackManager.AddProtectedMetacategory(SideDeckManager.SIDE_DECK);
        }

        private static void RegisterMetacategories()
        {
            try
            {
                RegisterMetacategoriesInner();
            }
            catch (Exception)
            {
                SideDecksPlugin.Log.LogInfo($"Error registering pack manager exception - pack manager plugin not loaded. This is not a problem.");
            }
        }

        internal static void RegisterCustomCards(Harmony harmony)
        {
            // Register the sigils
            RegisterCustomAbilities(harmony);

            // Register the protected metacategories
            RegisterMetacategories();

            // Update all of the old style side deck cards
            CardManager.ModifyCardList += delegate(List<CardInfo> cards)
            {
                foreach (CardInfo card in cards.Where(c => c.HasTrait(SideDeckManager.BACKWARDS_COMPATIBLE_SIDE_DECK_MARKER)))
                {
                    card.SetSideDeck(card.temple, 10);
                    card.traits.Remove(SideDeckManager.BACKWARDS_COMPATIBLE_SIDE_DECK_MARKER);
                }

                return cards;
            };

            // me trying to add conduit squirrel
            CardManager.New(SideDecksPlugin.CardPrefix,
                    "MetalSquirrel",
                    "Metal Squirrel",
                    0, 1,
                    "A squirel that can complete circuits.")
                .SetSideDeck(CardTemple.Tech, 5)
                .SetPortrait(Resources.Load<Texture2D>("art/cards/portraits/portrait_metal_squirrel"))
                .SetPixelPortrait(Resources.Load<Texture2D>("art/gbc/cards/pixelportraits/pixelportrait_metal_squirrel"))
                .AddAbilities(Ability.ConduitNull);
        }
    }
}